.job_template: &build_container
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script: &base_script
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        tag=""
        echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
      else
        tag=":$CI_COMMIT_REF_SLUG"
        echo "Running on branch '$CI_COMMIT_BRANCH': tag = $tag"
      fi
    - |
      if [[ "$CI_JOB_NAME" == "ckan" ]]; then
        dockerfile="Dockerfile"
      else
        dockerfile="contrib/docker/$CI_JOB_NAME/Dockerfile"
      fi;
      extra="/$CI_JOB_NAME"
    - docker pull "$CI_REGISTRY_IMAGE${extra}" || true
    - docker build --pull -t "$CI_REGISTRY_IMAGE${extra}${tag}" --file "${dockerfile}" .
    - docker push "$CI_REGISTRY_IMAGE${extra}${tag}"

ckan:
  <<: *build_container

postgresql:
  <<: *build_container

solr:
  <<: *build_container
